## ngtcp2-1.19.0-1.src.tar.zst

=== crypto/ossl/CMakeLists.txt ===
# ngtcp2

# Copyright (c) 2025 ngtcp2

# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:

# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.

# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

add_definitions(-DBUILDING_NGTCP2)

set(ngtcp2_crypto_ossl_SOURCES
  ossl.c
  ../shared.c
)

set(ngtcp2_crypto_ossl_INCLUDE_DIRS
  "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/lib>"
  "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/crypto/includes>"
  "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/crypto/includes>"
  "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/crypto>"
  "$<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/crypto>"
)

foreach(name libngtcp2_crypto_ossl.pc)
  configure_file("${name}.in" "${name}" @ONLY)
endforeach()

# Public shared library
if(ENABLE_SHARED_LIB)
  add_library(ngtcp2_crypto_ossl SHARED ${ngtcp2_crypto_ossl_SOURCES})
  set_target_properties(ngtcp2_crypto_ossl PROPERTIES
    COMPILE_FLAGS "${WARNCFLAGS}"
    VERSION ${CRYPTO_OSSL_LT_VERSION}
    SOVERSION ${CRYPTO_OSSL_LT_SOVERSION}
    C_VISIBILITY_PRESET hidden
    POSITION_INDEPENDENT_CODE ON
  )
  target_include_directories(ngtcp2_crypto_ossl PUBLIC
    ${ngtcp2_crypto_ossl_INCLUDE_DIRS})
  target_link_libraries(ngtcp2_crypto_ossl PUBLIC ngtcp2 OpenSSL::SSL)

  install(TARGETS ngtcp2_crypto_ossl
    EXPORT "${PROJECT_NAME}Targets"
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")
endif()

if(ENABLE_STATIC_LIB)
  # Public static library
  add_library(ngtcp2_crypto_ossl_static STATIC ${ngtcp2_crypto_ossl_SOURCES})
  set_target_properties(ngtcp2_crypto_ossl_static PROPERTIES
    COMPILE_FLAGS "${WARNCFLAGS}"
    VERSION ${CRYPTO_OSSL_LT_VERSION}
    SOVERSION ${CRYPTO_OSSL_LT_SOVERSION}
    ARCHIVE_OUTPUT_NAME ngtcp2_crypto_ossl${STATIC_LIB_SUFFIX}
    C_VISIBILITY_PRESET hidden
  )
  target_compile_definitions(ngtcp2_crypto_ossl_static PUBLIC
    "-DNGTCP2_STATICLIB")
  target_include_directories(ngtcp2_crypto_ossl_static PUBLIC
    ${ngtcp2_crypto_ossl_INCLUDE_DIRS})
  target_link_libraries(ngtcp2_crypto_ossl_static PUBLIC ngtcp2_static OpenSSL::SSL)

  install(TARGETS ngtcp2_crypto_ossl_static
    EXPORT "${PROJECT_NAME}Targets"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}")
endif()

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/libngtcp2_crypto_ossl.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")

=== PKGBUILD ===
# Contributor: Christoph Reiter <reiter.christoph@gmail.com>

pkgbase=ngtcp2
pkgname=("libngtcp2" "libngtcp2-devel")
pkgver=1.19.0
pkgrel=1
pkgdesc="An effort to implement IETF QUIC protocol"
arch=(i686 x86_64)
url='https://nghttp2.org/ngtcp2'
msys2_repository_url='https://github.com/ngtcp2/ngtcp2'
license=('spdx:MIT')
makedepends=(
  "gcc"
  "cmake"
  "ninja"
  "openssl-devel"
)
source=("https://github.com/ngtcp2/ngtcp2/releases/download/v${pkgver}/ngtcp2-${pkgver}.tar.xz"{,.asc})
sha256sums=('f11f7da5065f2298f8b5f079a11f1a6f72389271b8dedd893c8eb26aba94bce9'
            'SKIP')
validpgpkeys=(
'F4F3B91474D1EB29889BD0EF7E8403D5D673C366' # Tatsuhiro Tsujikawa <tatsuhiro.t@gmail.com>
)

build() {
  mkdir -p "${srcdir}/build-${CARCH}" && cd "${srcdir}/build-${CARCH}"

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  cmake \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=/usr \
    "${extra_config[@]}" \
    -DENABLE_LIB_ONLY=ON \
    -DENABLE_OPENSSL=ON \
    -DBUILD_SHARED_LIBS=ON \
    "../${pkgbase}-${pkgver}"

  cmake --build .
}

package_libngtcp2() {
  pkgdesc+=" - runtime libraries"
  depends=(
    "gcc-libs"
    "libopenssl"
  )

  cd "${srcdir}/build-${CARCH}"

  DESTDIR="${pkgdir}" cmake --install .

  # Remove on the next update
  cp "${pkgdir}/usr/bin/msys-ngtcp2_crypto_ossl-0.dll" "${pkgdir}/usr/bin/msys-ngtcp2_crypto_ossl.dll"

  rm -rf "${pkgdir}/usr/include"
  rm -rf "${pkgdir}/usr/lib"
  rm -rf "${pkgdir}/usr/share"

  install -Dm644 "${srcdir}/${pkgbase}-${pkgver}/COPYING" "${pkgdir}/usr/share/licenses/${pkgname}/COPYING"
}

package_libngtcp2-devel() {
  pkgdesc+=" - development files"
  depends=("libngtcp2" "openssl-devel")

  cd "${srcdir}/build-${CARCH}"

  DESTDIR="${pkgdir}" cmake --install .

  rm -rf "${pkgdir}"/usr/bin
}
